<template>
  <el-dialog :title="title" :close-on-click-modal="false" :visible.sync="visible">
    <el-form
      :model="dataForm"
      :rules="dataRule"
      ref="dataForm"
      @keyup.enter.native="handleConfirm()"
      label-width="80px"
    >
      <el-form-item label="角色名称" prop="roleName">
        <el-input
          clearable
          maxlength="20"
          show-word-limit
          :readonly="disable"
          v-model="dataForm.roleName"
          placeholder="角色名称"
        ></el-input>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input
          clearable
          maxlength="30"
          show-word-limit
          v-model="dataForm.remark"
          :readonly="disable"
          placeholder="备注"
        ></el-input>
      </el-form-item>
      <el-form-item size="mini" label="授权">
        <el-tree
          :data="menuList"
          :props="menuListTreeProps"
          node-key="menuId"
          ref="menuListTree"
          :default-expand-all="true"
          :default-checked-keys="defaultCheckedKeys"
          :filter-node-method="filterNode"
          show-checkbox
        >
          <span class="custom-tree-node" slot-scope="{ node, data }">
            <span>{{ node.label }}</span>
          </span>
        </el-tree>
      </el-form-item>
    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button v-if="!disable" @click="visible = false">取消</el-button>
      <el-button type="primary" @click="handleConfirm">确定</el-button>
    </span>
  </el-dialog>
</template>

<script>
import { treeDataTranslate } from '@/utils'
import { apiSysMenuList, apiSysRoleInfo, apiSysRoleConfirm } from '@/api/api_sys'

export default {
  data () {
    return {
      disable: null,
      visible: false,
      menuList: [],
      menuListTreeProps: {
        label: 'name',
        children: 'children'
      },
      defaultCheckedKeys: [],
      dataForm: {
        id: 0,
        roleName: '',
        remark: ''
      },
      dataRule: {
        roleName: [{ required: true, message: '角色名称不能为空', trigger: 'blur' }]
      },
      tempKey: -666666, // 临时key, 用于解决tree半选中状态项不能传给后台接口问题. # 待优化
      apiType: '' // api类型
    }
  },
  mounted () {
  },
  computed: {
    title () {
      if (this.disable) {
        return '已授权菜单'
      }
      if (!this.dataForm.id) {
        return '新增角色'
      } else {
        return '编辑角色'
      }
    }
  },
  methods: {
    async init (id, disable) {
      this.disable = disable
      this.dataForm = {}
      await this.handleGetSysMenuList()
      if (id) {
        this.dataForm.id = id || 0
        this.handleEdit()
        this.apiType = '/update'
      } else {
        this.apiType = '/save'
      }
    },
    // 获取权限列表
    async  handleGetSysMenuList () {
      let res = await apiSysMenuList({})
      this.menuList = treeDataTranslate(res, 'menuId')
      this.visible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].resetFields()
        this.$refs.menuListTree.setCheckedKeys([])
      })
    },
    // 编辑
    handleEdit () {
      apiSysRoleInfo({}, `/${this.dataForm.id}`).then(res => {
        if (res && res.code === 0) {
          this.dataForm = Object.assign({}, this.dataForm, res.role)
          var idx = res.role.menuIdList.indexOf(this.tempKey)
          if (idx !== -1) {
            res.role.menuIdList.splice(idx, res.role.menuIdList.length - idx)
          }
          if (this.disable) {
            this.$refs.menuListTree.filter(res.role.menuIdList)
          }
          this.defaultCheckedKeys = res.role.menuIdList
        }
      })
    },
    filterNode (value, data) {
      console.log('data: ', data)
      console.log('value: ', value)
      data.disabled = true
      return value.includes(data.menuId)
    },
    // 提交
    handleConfirm () {
      if (this.disable) {
        this.visible = false
        return
      }
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          let params = {
            'roleId': this.dataForm.id || undefined,
            'roleName': this.dataForm.roleName,
            'remark': this.dataForm.remark,
            'menuIdList': [].concat(this.$refs.menuListTree.getCheckedKeys(), [this.tempKey], this.$refs.menuListTree.getHalfCheckedKeys())
          }
          apiSysRoleConfirm(params, this.apiType).then(res => {
            if (res && res.code === 0) {
              this.$message({
                message: '操作成功',
                type: 'success',
                duration: 1500,
                onClose: () => {
                  this.visible = false
                  this.$emit('refreshDataList')
                }
              })
            } else {
              this.$message.error(res.msg)
            }
          })
        }
      })
    }
  }
}
</script>
